<h1>eZ publish 3 definitions</h1>


<p>
You should understand the following concepts before starting to develop with eZ publish.
Visit the <a href={"/sdk"|ezurl}>SDK documentation</a> for more info on the definitions.
</p>

<h2>Content class</h2>
<p>
In eZ publish you can define your own content classes. This is an object
definition if you like. Some examples of content classes are article, forum,
product and user account.
</p>

<p>
The concept of classes makes adding new content to the site very easy. Users
can start making new content objects immediately by entering data into templates
that is auto-generated by eZ publish. Adding new attributes to content classes
can be done at any time with no change in code or database required.
Using the content structure, users can easily add new categories and
sub-categories for the site.
</p>

<h2>Content class attribute</h2>
<p>
Each class consists of several attributes. The attributes or elements define the
name and behaviour of the class. For example an article content class may
consist of the attributes: title, intro and body. The title could be a string
data type; the intro and body could be XML formatted text.
</p>

<h2>Content object</h2>
<p>
A content object is an instance of a defined content class. The content class
defines the structure of content objects. The content object is the actual
documents/articles etc. that are stored in eZ publish. For instance,
a Music category is an instance of the Category class. An article about
U2 would be an instance of the Article class. The user Peter is
an instance of the User class.
</p>

<h2>Content object version</h2>
<p>
Each content object can exist in several versions. This is to keep track of
changes and to be able to revert changes in an object.
</p>

<h2>Content object attribute</h2>
<p>
Each content object consists of several attributes. These attributes are defined
by a content class attribute. The content object attribute contains the actual
data.
</p>

<h2>Content object tree</h2>
<p>
The content object tree is the tree structure representation of all the
content on your site. Any node in the tree is a content class instance - a
content object. A content object always has a primary parent node, but may also
be attached to several other nodes. There is no limit on number of levels in the
object structure tree.
</p>

<h2>How to make an object</h2>
<p>
Making or editing objects in eZ publish 3 is designed to be simple and fast.
It is all done in the admin interface. In the content view you
will find a button called <b>New</b>. Next to this button you will find a
drop down menu consisting of the available classes, folder, article,
picture etc. When you highlight one of these and click <b>New</b>, you will be
redirected to the <b>Edit</b> window, which contains a form. When you have entered
your data and saved it, you have made an object.
</p>

<p>
You will find more information about this in the User Manual.
</p>
